# -*- coding: utf-8 -*-

import ast
import base64
import functools

import os
import logging

import simplejson
import werkzeug
import sys


from openerp.tools.translate import _
from openerp import http

from openerp.http import request, serialize_exception as _serialize_exception
from openerp.addons.web.controllers.main import Binary as MainBinary

_logger = logging.getLogger(__name__)


def serialize_exception(f):
    @functools.wraps(f)
    def wrap(*args, **kwargs):
        try:
            return f(*args, **kwargs)
        except Exception, e:
            _logger.exception("An exception occured during an http request")
            se = _serialize_exception(e)
            error = {
                'code': 200,
                'message': "Odoo Server Error",
                'data': se
            }
            return werkzeug.exceptions.InternalServerError(simplejson.dumps(error))
    return wrap

class Binary(MainBinary):

    @http.route('/web/binary/upload_attachment', type='http', auth="user")
    @serialize_exception
    def upload_attachment(self, callback, model, id, ufile, **kwargs): # file_name=False):
        Model = request.session.model('ir.attachment')
        out = """<script language="javascript" type="text/javascript">
                    var win = window.top.window;
                    win.jQuery(win).trigger(%s, %s);
                </script>"""
        
        if kwargs and 'file_name' in kwargs.keys():
            file_name = kwargs['file_name']
            if len(file_name) == 0:
                args = {'error': _("You should set attachment name!")}
                return out % (simplejson.dumps(callback), simplejson.dumps(args))
            #setting = request.session.model('knowledge.config.settings').browse([1])
            #print setting.attachment_name
            #if setting and setting.attachment_name and not file_name:
            #    args = {'error': _("You should set attachment name!")}
            file_type = '.' + ufile.filename.split('.')[-1]

            if file_type != file_name[-len(file_type)-1:]:
                ufile.filename = file_name + file_type
            else:
                ufile.filename = file_name

        res = super(Binary, self).upload_attachment(callback, model, id, ufile)
        return res