(function() {

var instance = openerp;
var _t = instance.web._t,
   _lt = instance.web._lt;
var QWeb = instance.web.qweb;


instance.web.Sidebar = instance.web.Sidebar.extend({
    init: function(parent) {
        var self = this;
        this._super(parent);
        var view = this.getParent();
        this.sections = [
            { 'name' : 'print', 'label' : _t('Print'), },
            { 'name' : 'other', 'label' : _t('More'), }
        ];
        this.items = {
            'print' : [],
            'other' : []
        };
        this.file_name = "";
        this.fileupload_id = _.uniqueId('oe_fileupload');
        $(window).on(this.fileupload_id, function() {
            var args = [].slice.call(arguments).slice(1);
            self.do_attachement_update(self.dataset, self.model_id,args);
            instance.web.unblockUI();
        });
    },
    on_attachment_changed: function(e) {
        var $e = $(e.target);
        var self = this;
        if ($e.val() !== '') {
            swal({
                title: _t("File name"),
                text: _t("Write new name or keep the old one:"),
                type: "input",
                showCancelButton: true,
                closeOnConfirm: false,
                confirmButtonColor: "rgb(85, 221, 95)",
                cancelButtonColor: "#DD6B55",
                confirmButtonText: _t("Upload"),
                cancelButtonText: _t("Cancel"),
                animation: "slide-from-top",
                inputPlaceholder: _t("Attachment name"),
                inputValue: $e[0].files[0].name
            },
            function(file_name){
                if (file_name === false) {
                    var win = window.top.window;
                    var callback = $e.parent()[0][0].value
                    win.jQuery(win).trigger(callback, {"error": _t("File was not upload!")});
                    return false;
                }
                if (file_name === "") {
                    swal.showInputError(_t("Attachment name can't be blank!"));
                    return false
                }
                swal({title: _t("File saved!"), timer: 1000, type:"success", showConfirmButton: false});
                //var file_name = prompt(_t("You can change filename:"), $e[0].files[0].name);

                $e.parent().find('#file_name').val(file_name);
                self.set('file_name', file_name);
                
                self.$el.find('form.oe_form_binary_form').submit();
                $e.parent().find('input[type=file]').prop('disabled', true);
                $e.parent().find('button').prop('disabled', true).find('img, span').toggle();
                self.$('.oe_sidebar_add_attachment span').text(_t('Uploading...'));

                instance.web.blockUI();
            
                
            });
            
        }
    },
});

})();